/* 
 * Linkoping Intelligent Communication of Knowledge System (LINCKS)
 *      Copyright (C) 1993, Lin Padgham, Ralph Rnnquist
 *       Department of Computer and Information Sciences
 *		University of Linkoping, Sweden
 *		    581 83 Linkoping, Sweden
 *		       lincks@ida.liu.se
 *
 * These collective LINCKS programs are free software; you can 
 * redistribute them and/or modify them under the terms of the GNU
 * General Public License as published by the Free Software Foundation,
 * version 2 of the License.
 *
 * These programs are distributed in the hope that they will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the programs; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* 
 * MODULE NAME: 	config.h
 *
 * SCCSINFO:		@(#)config.h	1.2 11/4/93
 *
 * ORIGINAL AUTHOR(S):  Martin Sjlin, 93-08-05
 *
 * MODIFICATIONS:
 *	<list mods with name and date>
 *
 * DESCRIPTION:
 * External declarations of stuff exported by libshared.  should be
 * included in anything using libshared for operating system stuff
 * compability.
 */

#ifndef CONFIG_H
#define CONFIG_H

/* dbcomm.c, mkpasswd.c */
#define PASSWD_LENGTH 64	/* how long the password might be */
#define PASSWD_FORMAT    "%s%d%s"
#define PASSWD_FORMAT_PR "%s %d %s\n"


/*
 * On SCO's ODT systems sco gets defined.  On systems running SCO Unix
 * and XFree86 SCO get's defined.  This just keeps me from checking for
 * both of 'em....
 */
#if defined(sco) && !defined(SCO)
#define SCO
#endif

#define INDEXLOCK ".indexfile.lock"

#ifndef RETSIGTYPE
#define RETSIGTYPE void
#endif

/* misc.c */
extern RETSIGTYPE (*Signal( /* int, void (*) (__harg)) */)) (/* __harg */);

#if !defined(BADSIG) && defined(SIG_DFL) 
#define BADSIG SIG_ERR
#endif /* n BADSIG && SIG_DFL */

#ifndef L_SET
#include <unistd.h>
#define L_SET           SEEK_SET
#endif

#ifndef L_INCR
#include <unistd.h>
#define L_INCR          SEEK_CUR
#endif

#ifndef L_XTND
#include <unistd.h>
#define L_XTND          SEEK_END
#endif

#ifndef HAVE_FLOCK
#include <unistd.h>
#include <fcntl.h>
extern int LockReg( /* int fd, int cmd, int type, off_t offset, 
                       int where, off_t len */ );
#define read_lock( fd, off, where, len) \
  LockReg( fd, F_SETLK, F_RDLCK, off, where, len)
#define readw_lock( fd, off, where, len) \
  LockReg( fd, F_SETLKW, F_RDLCK, off, where, len)
#define write_lock( fd, off, where, len) \
  LockReg( fd, F_SETLK, F_WRLCK, off, where, len)  
#define writew_lock( fd, off, where, len) \
  LockReg( fd, F_SETLKW, F_WRLCK, off, where, len)  
#define un_lock( fd, off, where, len) \
  LockReg( fd, F_SETLK, F_UNLCK, off, where, len)
#endif /* n HAVE_FLOCK */

#endif /* CONFIG_H */
