/* 
 * Linkoping Intelligent Communication of Knowledge System (LINCKS)
 *      Copyright (C) 1993, Lin Padgham, Ralph Rnnquist
 *       Department of Computer and Information Sciences
 *		University of Linkoping, Sweden
 *		    581 83 Linkoping, Sweden
 *		       lincks@ida.liu.se
 *
 * These collective LINCKS programs are free software; you can 
 * redistribute them and/or modify them under the terms of the GNU
 * General Public License as published by the Free Software Foundation,
 * version 2 of the License.
 *
 * These programs are distributed in the hope that they will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the programs; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* 
 * MODULE NAME: 	libshared.h
 *
 * SCCSINFO:		@(#)libshared.h	1.1 9/27/93
 *
 * ORIGINAL AUTHOR(S):  David Partain, 1993-06-16
 *
 * MODIFICATIONS:
 *	<list mods with name and date>
 *
 * DESCRIPTION:
 * External declarations of stuff exported by libshared.  should be
 * included in anything using libshared.
 */

#ifndef LIBSHARED_H
#define LIBSHARED_H


#ifndef LABEL_DEFINED
typedef long LABEL;
#define LABEL_DEFINED
#endif /* LABEL_DEFINED */

/* Link data structure definitions */
#ifndef LINKGROUP_DEFINED	/* defined in dbserver.h. duplicated here.*/

/* Linkitem */
typedef struct linkitem_struct {
  LABEL label;
  LABEL vs;
  struct linkitem_struct *nextitem;
} LINKITEM;

/* Links */
typedef struct links_struct {
  char *tag;
  LINKITEM *linkitem;
  struct links_struct *nextlinks;
} LINKS;

/* Linkgroup */
typedef struct linkgroup_struct {
  char *name;
  LINKS *links;
  struct linkgroup_struct *nextgroup;
} LINKGROUP;
#define LINKGROUP_DEFINED
#endif /* LINKGROUP_DEFINED */

/* links.c */
extern void FreeLinks( /* LINKGROUP *lg */ );
extern LINKGROUP *DelLink( /* LINKGROUP *linkroot, char *name, 
			      char *tag, LABEL vs, LABEL label */ );
extern LINKGROUP *AddLink( /* LINKGROUP *linkroot, char *name,
			      char *tag, LABEL vs, LABEL label */ );

/* logging.c */
extern void LogFile( /* va_alist */ );
extern void LogMessage( /* va_alist */ );

/* misc.c */
extern char *strdup( /*  char *input  */ );
extern int readlockit( /* int fd, off_t pos, off_t size */ );
extern int writelockit( /* int fd */ );
extern void unlockit( /* int fd, off_t pos, off_t size */ );

/* packunpack.c */
extern int PackGroup( /* LINKGROUP *group, PACKEDBUFF *pbuff */ );
extern int UnpackGroup( /* LINKGROUP **group,PACKEDBUFF *pbuff */ );

/* xconfig.c */
extern char *LL_GetConfig( /* char *tag */ );
extern long LL_GetConfigl( /* char *tag */ );
extern int configuration( /* char *dbdir */ );

/* xdr.c */
extern int xdr_access( /* XDR *xdrsp, A_ENTRY *a_entry */ );
extern int xdr_checkno( /* XDR *xdrsp, C_ENTRY *c_entry */ );
extern int xdr_new( /* XDR *xdrsp, N_ENTRY *n_entry */ );
extern int xdr_label( /* XDR *xdrsp, L_ENTRY *l_entry */ );
extern int xdr_update( /* XDR *xdrsp, U_ENTRY *u_entry */ );
extern int xdr_edit( /* XDR *xdrsp, E_ENTRY *e_entry */ );
extern int xdr_remove( /* XDR *xdrsp, R_ENTRY *r_entry */ );
extern int xdr_prot( /* XDR *xdrsp, P_ENTRY *p_entry */ );
extern int xdr_setprot( /* XDR *xdrsp, S_ENTRY *s_entry */ );

#endif /* LIBSHARED_H */
