/* 
 * Linkoping Intelligent Communication of Knowledge System (LINCKS)
 *      Copyright (C) 1993, Lin Padgham, Ralph Rnnquist
 *       Department of Computer and Information Sciences
 *		University of Linkoping, Sweden
 *		    581 83 Linkoping, Sweden
 *		       lincks@ida.liu.se
 *
 * These collective LINCKS programs are free software; you can 
 * redistribute them and/or modify them under the terms of the GNU
 * General Public License as published by the Free Software Foundation,
 * version 2 of the License.
 *
 * These programs are distributed in the hope that they will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the programs; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* 
 * MODULE NAME:         systypes.h
 *
 * SCCSINFO:            @(#)systypes.h	1.2 11/4/93
 *
 * ORIGINAL AUTHOR(S):  David Partain, 1992-11-24
 *
 * MODIFICATIONS:
 *	<name and date and description>
 * DESCRIPTION:
 * 
 * Contains some declaration that Sun doesn't have in standard
 * include files or things that are screwy.  This is supposed to
 * keep lint happy.
 */
#ifndef SYSTYPES_H
#define SYSTYPES_H

#if defined(sun) && !defined(SVR4)
extern int accept();
extern unsigned int alarm();
extern int atoi();
extern int bind();
extern int callrpc();
extern int chdir();
extern int close();
extern int connect();
extern int creat();
#ifdef CRYPT_PASSWD
extern char *crypt();
#endif	/* CRYPT_PASSWD */
extern int dup2();
extern int execl();
extern int fclose();
extern int fflush();
extern int flock();
extern int fork();
extern int fprintf();
extern int fputs();
extern int fscanf();
extern int getdtablesize();
extern int getopt();
extern char *getenv();
extern int gethostname();
extern int getopt();
extern int getpid();
extern int ioctl();
extern int listen();
extern int lockf();
extern long lseek();
extern int pipe();
extern int printf();
extern long random();
extern int read();
extern int recv();
extern int registerrpc();
extern int scanf();
extern int select();
extern int send();
extern int setlinebuf();
extern int setsockopt();
extern unsigned sleep();
extern int socket();
extern char *sprintf();
extern int sscanf();
extern long strtol();
extern char *strcpy();
extern void svc_run();
extern int system();
extern int tolower();
extern void usleep();
extern int vfprintf();
extern int vprintf();
#if !(defined(SYSV) || defined(SVR4))	/* solaris has this in stdio */
extern int vsprintf();
#endif
extern int xdr_label();
extern int xdr_new();
extern int wait3();
extern int write();
extern int _flsbuf();
extern int _filbuf();	/* _filbuf is used in the macro getchar */
#ifdef lint	
extern void exit(); /* this is right.  stdlib.h is wrong */
#ifndef SVR4
extern int bzero(); /* the sun lint library lies:  both really return void */
#endif /* n SVR4 */
extern int perror();
#else
/* exit() in stdlib.h claims it returns int.  it lies. */
extern void bzero();
extern void perror();
#endif /* lint */

#endif /* sun */

#ifdef SVR4
#include <memory.h>
#define bzero(src,cnt) memset((char *)(src),(int)(cnt),0)
#endif /* SVR4 */

#endif /* SYSTYPES_H */
