/* 
 * Linkoping Intelligent Communication of Knowledge System (LINCKS)
 *      Copyright (C) 1993, Lin Padgham, Ralph Rnnquist
 *       Department of Computer and Information Sciences
 *		University of Linkoping, Sweden
 *		    581 83 Linkoping, Sweden
 *		       lincks@ida.liu.se
 *
 * These collective LINCKS programs are free software; you can 
 * redistribute them and/or modify them under the terms of the GNU
 * General Public License as published by the Free Software Foundation,
 * version 2 of the License.
 *
 * These programs are distributed in the hope that they will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the programs; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/*
 * MODULE NAME:		parserP.h
 *
 * SCCSINFO:		@(#)parserP.h	1.1 9/27/93
 *
 * ORIGINAL AUTHOR(S):	Ralph Ronnquist, ????
 *
 * MODIFICATIONS:
 *	<list mods with name and date>
 *
 * DESCRIPTION:
 * 	Private .h file used internally in the parser.
 *	It contains core definitions for the parser module.
 */

#ifndef PARSERP_H
#define PARSERP_H

#define DSTACKLIMIT	200
#define INBUFLIMIT	5000

#define TERMTOK	(0)
#define NONTERM (1)
#define WTOKEN	(2)
#define UTOKEN	(3)
#define ENDING	(4)

#define new(record)	(record *) malloc((unsigned) sizeof(record))
#define maplist(p,lst)	for(p=lst;p!=0;p=p->nextp)

#define acceptable(n)	((n)>0)

#define poprule	rulestack[rulesp--]
#define pushrule(r)	rulestack[++rulesp] = (r)
#define toprule	rulestack[rulesp]

#define poptoken tokenstack[toksp--]
#define pushtoken(tok)	tokenstack[++toksp] = (tok)
#define toptoken tokenstack[toksp]

#endif	/* PARSERP_H */
